#define FAKE //  -      .

#ifdef FAKE
  int OnInit() { TesterWithdrawal(1); return(INIT_SUCCEEDED); }
#else // FAKE

sinput uint inInSampleDays = 28;     // InSampleDays
sinput uint inOutSampleDays = 14;    // OutSampleDays
sinput bool inWithHolidays = true;   // With Holidays

// https://www.mql5.com/ru/forum/170952/page159#comment_14726390
input string inFolderName = "";      // FolderName (Empty - Create Tasks)
input string inOutSampleSymbol = ""; // OutSampleSymbol (Empty - not change)

#define REPORT_BROWSER            //      -   DLL.
#define REPORT_TESTER             //      
#define REPORT_TESTER_INPUTS      //          -   DLL.
#define REPORT_INTERACTIVE_CHARTS //     .
#include <Report.mqh> // https://www.mql5.com/ru/code/16006

#include <fxsaber\Validate\ValidateTasks.mqh>
#include <fxsaber\Validate\Validate.mqh>

VALIDATE* Validate = NULL;

int OnInit()
{
  if (MQLInfoInteger(MQL_OPTIMIZATION))
    return(INIT_FAILED);

  if ((inOutSampleSymbol != "") && !SymbolInfoInteger(inOutSampleSymbol, SYMBOL_SELECT))
  {
    ::Alert("The symbol " + inOutSampleSymbol + " is not found.");

    return(INIT_FAILED);
  }

  const string FolderName = ((inFolderName == "") && !MQLInfoInteger(MQL_TESTER)) ?
                            VALIDATETASKS::Create(inInSampleDays, inOutSampleDays, __FILE__, inWithHolidays) :
                            (inFolderName + (!StringLen(inFolderName) || (inFolderName[StringLen(inFolderName) - 1] != '\\') ? "\\" : NULL));
  const bool Res = (FolderName != NULL) && EventSetTimer(1);

  if (Res)
  {
/*
    if (!MQLInfoInteger(MQL_TESTER))
    {
      Print(ChartSetInteger(0, CHART_SHOW, false));
      Print(ChartSetInteger(0, CHART_IS_DOCKED, false));
    }
*/
    Validate = new VALIDATE(FolderName, inOutSampleSymbol);

    OnTimer();
  }

  return(Res ? INIT_SUCCEEDED : INIT_FAILED);
}

void OnDeinit( const int )
{
  if (Validate)
    delete Validate;
}

void OnTimer()
{
  if (Validate)
  {
    if (Validate.IsFinish())
      ExpertRemove();
    else
      Validate.OnTimer();
  }
}

void OnTick()
{
  if (Validate)
    Validate.OnTick();
}

void OnChartEvent( const int id, const long &lparam, const double &dparam, const string &sparam )
{
  if (Validate)
    Validate.OnChartEvent(id, lparam, dparam, sparam);
}

#endif // FAKE