#include <fxsaber\MultiTester\MTTester.mqh> // https://www.mql5.com/ru/code/26132

#include "ValidateBase.mqh"

class VALIDATETASK : public VALIDATEBASE
{
private:
  const string OutSampleSymbol;

  string StrTask;
  bool RunFlag;

public:
  bool IsOptimization( void ) const
  {
    string StrTmp = this.StrTask;

    return((bool)(int)VALIDATETASK::StringBetween(StrTmp, "Optimization=", "\r\n"));
  }

  string GetOutSampleSettings( void ) const
  {
    string StrRes = NULL;

    string StrTmp = this.StrTask;
    string StrOOS = VALIDATETASK::StringBetween(StrTmp, "; OutSample: ", " (");

    if (StrOOS != NULL)
    {
      StrRes = this.StrTask;

      VALIDATETASK::StringReplace(StrRes,"Optimization=", "\r\n", "0"); // Single Mode
      VALIDATETASK::StringReplace(StrRes,"Model=", "\r\n", "4"); // Real Ticks

      VALIDATETASK::StringReplace(StrRes, "FromDate=", "\r\n", VALIDATETASK::StringBetween(StrOOS, NULL, "-"));
      VALIDATETASK::StringReplace(StrRes, "ToDate=", "\r\n", StrOOS);

      if (this.OutSampleSymbol != "")
        VALIDATETASK::StringReplace(StrRes, "Symbol=", "\r\n", this.OutSampleSymbol);
    }

    return(StrRes);
  }

  bool Load( const string FileName )
  {
    uchar Bytes[];

    const bool Res = (::FileLoad(FileName, Bytes) > 0);

    this.StrTask = Res ? ::CharArrayToString(Bytes) : NULL;
    this.RunFlag = false;

    if (Res && !this.IsOptimization() && (this.OutSampleSymbol != ""))
      VALIDATETASK::StringReplace(this.StrTask, "Symbol=", "\r\n", this.OutSampleSymbol);

    return(Res);
  }

  VALIDATETASK( const string sOutSampleSymbol = "" ) : StrTask(NULL), RunFlag(false), OutSampleSymbol(sOutSampleSymbol)
  {
  }

  bool Run( void )
  {
    return((this.StrTask != NULL) && !this.RunFlag
           ? (this.RunFlag = MTTESTER::IsReady() && MTTESTER::SetSettings2(this.StrTask) && MTTESTER::ClickStart())
           : false);
  }

  bool IsFinish( void ) const
  {
    return((this.StrTask == NULL) || (this.RunFlag && MTTESTER::IsReady()));
  }
};